BINDRESVPORT(3)

NAME
bindresvport - bind a socket to a privileged IP port

LIBRARY
libc

SYNOPSIS
#include <sys/types.h>
#include <netinet/in.h>
int
bindresvport(int sd, struct sockaddr_in *sin);

DESCRIPTION
bindresvport() is used to bind a socket descriptor to a privileged IP port, that is, a port number in the range 0-1023. The routine returns 0 if it is successful, otherwise -1 is returned and errno set to reflect the cause of the error.

If sin is a pointer to a struct sockaddr_in then the appropriate fields in the structure should be defined. If sin.sin_port is ‘0’ then an anonymous port (in the range 600-1023) will be chosen, and if bind(2) is successful, the sin.sin_port will be updated to contain the allocated port.

If sin is the NULL pointer, an anonymous port will be allocated (as above). However, there is no way for bindresvport() to return the allocated port in this case.

Only root can bind to a privileged port; this call will fail for any other users.

RETURN VALUES
If the bind is successful, a 0 value is returned. A return value of -1 indicates an error, which is further specified in the global errno.

ERRORS

[EPFNOSUPPORT]
    If sin was supplied, and sin.sin_family isn't AF_INET.

bindresvport() may also fail and set errno for any of the errors specified for the calls bind(2), getsockopt(2), or setsockopt(2).

SEE ALSO
bind(2), getsockopt(2), setsockopt(2), ip(4).